#include "aib.h"
#include "extern.h"


int ids[12]={BUTTON_KIND,CHECKBOX_KIND,CYCLE_KIND,INTEGER_KIND,LISTVIEW_KIND,
MX_KIND,NUMBER_KIND,PALETTE_KIND,SCROLLER_KIND,SLIDER_KIND,STRING_KIND,TEXT_KIND};

/* prototypes */
void gadsub_menu(void);
struct Gadget *conditional_gadgets(struct Gadget *);


/************************** gadsub ***************************************/
         
void gadsub_menu(void)
{
   UWORD top;              /* offset into Window under titlebar */
   struct NewGadget ng;    /* for Gadget positioning */
   struct Gadget *gad;     /* our running Gadget pointer */
   
   top = window->BorderTop + 1;
   gad =  CreateContext(&glist);


   /* now we can fill out the NewGadget structure to describe where we want
      the Gadget to be placed */
 
   ng.ng_TextAttr = &topaz80;
   ng.ng_VisualInfo = vi;
   ng.ng_Flags = 0;
  
   ng.ng_LeftEdge = 170;
   ng.ng_TopEdge = top + 10;
   ng.ng_Width = 300;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_user;
   ng.ng_GadgetText="Variable *name:";
    g1user=gad = CreateGadget(STRING_KIND,gad,&ng,
	  GTST_MaxChars,240,
	  GTST_String, (currgad)?currgad->name:NULL,
          GT_Underscore, '*',
          TAG_DONE);
  
   ng.ng_LeftEdge = 130;
   ng.ng_TopEdge = top + 30;
   ng.ng_Width = 55;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_left;
   ng.ng_GadgetText="ng_*LeftEdge";
    g1left=gad = CreateGadget(INTEGER_KIND,gad,&ng,
	  GTIN_MaxChars,4,
	  GTIN_Number,(currgad)?currgad->l:0,
          GT_Underscore, '*',
          TAG_DONE);
  
   ng.ng_LeftEdge = 130;
   ng.ng_TopEdge = top + 50;
   ng.ng_Width = 55;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_top;
   ng.ng_GadgetText="ng_*TopEdge";
    g1top=gad = CreateGadget(INTEGER_KIND,gad,&ng,
	  GTIN_MaxChars,4,
	  GTIN_Number,(currgad)?currgad->t:0,
          GT_Underscore, '*',
          TAG_DONE);
         
  
   ng.ng_LeftEdge = 130;
   ng.ng_TopEdge = top + 70;
   ng.ng_Width = 55;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_widt;
   ng.ng_GadgetText="ng_*Width";
    g1widt=gad = CreateGadget(INTEGER_KIND,gad,&ng,
	  GTIN_MaxChars,4,
	  GTIN_Number,(currgad)?currgad->w:0,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 130;
   ng.ng_TopEdge = top + 90;
   ng.ng_Width = 55;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_height;
   ng.ng_GadgetText="ng_*Height*";
    g1height=gad = CreateGadget(INTEGER_KIND,gad,&ng,
	  GTIN_MaxChars,4,
	  GTIN_Number,(currgad)?currgad->h:0, /* do font thing here... ?*/
          GT_Underscore, '*',
          TAG_DONE);
  
   ng.ng_LeftEdge = 330;
   ng.ng_TopEdge = top + 30;
   ng.ng_Width = 180;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_text;
   ng.ng_GadgetText="ng_*GadgetText";
    g1text=gad = CreateGadget(STRING_KIND,gad,&ng,
	  GTST_MaxChars,240,
	  GTST_String, (currgad)?currgad->text:NULL,
          GT_Underscore, '*',
          TAG_DONE);
    
   ng.ng_LeftEdge = 310;
   ng.ng_TopEdge = top + 90;
   ng.ng_Width = 50;
   ng.ng_Height = 12;
   ng.ng_GadgetID = GA_disa;
   ng.ng_GadgetText="GA_Disable";
    gadisa=gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
          GT_Underscore, '*',
	  GTCB_Checked,(currgad)?currgad->dis:FALSE,
          TAG_DONE);

   ng.ng_LeftEdge = 130;
   ng.ng_Width = 55;
   ng.ng_Height = 15;
   ng.ng_TopEdge = top + 110;
   ng.ng_GadgetID = GT_Under;
   ng.ng_GadgetText="GT_Underscore";
    gtunder=gad = CreateGadget(STRING_KIND,gad,&ng,
          GTST_MaxChars,1,
	  GTST_String,(currgad)?currgad->under:"_",
          TAG_DONE);

   ng.ng_LeftEdge = 30;
   ng.ng_TopEdge = top + 132; 
   ng.ng_Width = 10;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_chfont;
   ng.ng_GadgetText="";
    g1chfont=curr_font = gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
	  GTCB_Checked,(currgad)?currgad->cfont:FALSE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 130;
   ng.ng_TopEdge = top + 130; 
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_font;
   ng.ng_GadgetText="Custom:";
    curr_font = gad = CreateGadget(TEXT_KIND,gad,&ng,
	  GTTX_Text,MyFont,
	  GTTX_Border,TRUE,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 290;
   ng.ng_TopEdge = top + 130; 
   ng.ng_Width = 35;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_fsize;
   ng.ng_GadgetText=NULL;
    font_size = gad = CreateGadget(NUMBER_KIND,gad,&ng,
	  GTNM_Number,GFontSize,
	  GTNM_Border,TRUE,
          GT_Underscore, '*',
          TAG_DONE);
    
   ng.ng_LeftEdge = 330;
   ng.ng_TopEdge = top + 50;
   ng.ng_Width = 135;
   ng.ng_Height = 12;
   ng.ng_GadgetID = G1_type;
   ng.ng_GadgetText="Gadget Type:";
    g1type=gad = CreateGadget(CYCLE_KIND,gad,&ng,
          GT_Underscore, '*',
	  GTCY_Active,(currgad)?currgad->type:0,
	  GTCY_Labels,kind_labels,
          TAG_DONE);

   ng.ng_LeftEdge = 330;
   ng.ng_TopEdge = top + 70;
   ng.ng_Width = 135;
   ng.ng_Height = 12;
   ng.ng_GadgetID = G1_place;
   ng.ng_GadgetText="PLACETEXT Flag";
    g1place=gad = CreateGadget(CYCLE_KIND,gad,&ng,
          GT_Underscore, '*',
	  GTCY_Active,(currgad)?currgad->type:0,
	  GTCY_Labels,LabelPlaces,
          TAG_DONE);
    
   ng.ng_LeftEdge = 480;
   ng.ng_TopEdge = top + 90;
   ng.ng_Width = 50;
   ng.ng_Height = 12;
   ng.ng_GadgetID = G1_high;
   ng.ng_GadgetText="NG_HIGHLABEL";
    g1high=gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
	  GTCB_Checked,(currgad)?currgad->ng:FALSE,
          GT_Underscore, '*',
          TAG_DONE);

    
   ng.ng_LeftEdge = 360;
   ng.ng_TopEdge = top + 130;
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_nfont;
   ng.ng_GadgetText="Choose Font...";
    g1nfont=gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
	  GA_Disabled,(currgad)?!currgad->cfont:TRUE,
          TAG_DONE);

   ng.ng_LeftEdge = 360;
   ng.ng_TopEdge = top + 160;
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_can;
   ng.ng_GadgetText="*Cancel";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
          TAG_DONE);

   ng.ng_LeftEdge = 30;
   ng.ng_TopEdge = top + 160;
   ng.ng_Width = 150;
   ng.ng_Height = 15;
   ng.ng_GadgetID = G1_ok;
   ng.ng_GadgetText="*OK";
    gad = CreateGadget(BUTTON_KIND,gad,&ng,
          GT_Underscore, '*',
          TAG_DONE);

 
    if (!gad)
      abort_me("Couldn't allocate the Gadget list.");

   AddGList(window, glist, (UWORD)-1, (UWORD)-1, NULL);
   RefreshGList(glist, window, NULL, (UWORD)-1);
   GT_RefreshWindow(window, NULL);
}


/************************* gadget menu conditionals *********************/

struct Gadget *conditional_gadgets(struct Gadget *gad)
{
 
   UWORD top;              /* offset into Window under titlebar */
   struct NewGadget ng;    /* for Gadget positioning */
   int gad_kind;

   if (currgad) gad_kind = ids[currgad->type];
   else gad_kind = 0;

   top = window->BorderTop + 1;
 
   ng.ng_TextAttr = &topaz80;
   ng.ng_VisualInfo = vi;
   ng.ng_Flags = PLACETEXT_ABOVE;

/* generic textview machine w add/delete buttons */
	 
	ng.ng_Width = 130;
	ng.ng_Height = 14;
	ng.ng_GadgetText = NULL;
	ng.ng_GadgetID = G_strview;
	  gad = CreateGadget(STRING_KIND,gad,&ng,
		GTST_MaxChars,50,
	        GA_DISABLED,(gad_kind==LISTVIEW_KIND || gad_kind==CYCLE_KIND ||
			   gad_kind==MX_KIND) ? FALSE : TRUE,
		TAG_DONE);

        ng.ng_LeftEdge = 15;
        ng.ng_TopEdge = top + 95;
        ng.ng_Width = 130;
        ng.ng_Height = 60;
        ng.ng_GadgetID = GTLV_Labels;
	ng.ng_GadgetText="List Objects";
          gad = CreateGadget(LISTVIEW_KIND,gad,&ng,
	    GTLV_Labels,&list,
	    GTLV_ShowSelected,gad,
	    LAYOUTA_SPACING,2,
            GT_Underscore, '*',
            TAG_DONE);

       ng.ng_Flags = PLACETEXT_IN;
       ng.ng_LeftEdge = 150;
       ng.ng_TopEdge = top + 95;
       ng.ng_Width = 38;
       ng.ng_Height = 12;
       ng.ng_GadgetID = G_a;
       ng.ng_GadgetText="ADD";
        gad = CreateGadget(BUTTON_KIND,gad,&ng,
              GT_Underscore, '*',
	      GA_DISABLED,(gad_kind==LISTVIEW_KIND || gad_kind==CYCLE_KIND ||
			   gad_kind==MX_KIND) ? FALSE : TRUE,
              TAG_DONE);

       ng.ng_LeftEdge = 150;
       ng.ng_TopEdge = top + 110;
       ng.ng_Width = 38;
       ng.ng_Height = 12;
       ng.ng_GadgetID = G_d;
       ng.ng_GadgetText="DEL";
        gad = CreateGadget(BUTTON_KIND,gad,&ng,
              GT_Underscore, '*',
	      GA_DISABLED,(gad_kind==LISTVIEW_KIND || gad_kind==CYCLE_KIND ||
			   gad_kind==MX_KIND) ? FALSE : TRUE,
              TAG_DONE);

       ng.ng_Flags = PLACETEXT_LEFT;

 if (!(currgad)) return (gad);   
 switch (gad_kind) {

  case CHECKBOX_KIND:  /***************************************************/
	
        ng.ng_LeftEdge = 355;
        ng.ng_TopEdge = top + 95;
        ng.ng_Width = 55;
        ng.ng_Height = 15;
        ng.ng_GadgetID = GTCB_chek;
	ng.ng_GadgetText="GTCB_Checked";
          gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
            GT_Underscore, '*',
            TAG_DONE);

	break;

  case SLIDER_KIND:  /*******************************************************/
	
	ng.ng_LeftEdge = 290;
	ng.ng_TopEdge = top + 85;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSL_min;
	ng.ng_GadgetText="GTSL_Min";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 290;
	ng.ng_TopEdge = top + 99;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSL_max;
	ng.ng_GadgetText="GTSL_Max";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 290;
	ng.ng_TopEdge = top + 113;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSL_leve;
	ng.ng_GadgetText="GTSL_Min";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 290;
	ng.ng_TopEdge = top + 127;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSL_maxl;
	ng.ng_GadgetText="GTSL_MaxLevelLen";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 290;
	ng.ng_TopEdge = top + 141;
	ng.ng_Width = 60;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSL_levf;
	ng.ng_GadgetText="GTSL_LevelFormat";
	   gad = CreateGadget(STRING_KIND,gad,&ng,
		GT_Underscore,'*',
		GTST_String,"%2ld",
		GTST_MaxChars,6,
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 85;
	ng.ng_Width = 90;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSL_levp;
	ng.ng_GadgetText="LevelPlace";
	   gad = CreateGadget(CYCLE_KIND,gad,&ng,
		GT_Underscore,'*',
		GTCY_Labels,LevelPlaces,
		TAG_DONE);
  
	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 99;
	ng.ng_Width = 90;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSL_disp;
	ng.ng_GadgetText="DispFunc";
	   gad = CreateGadget(STRING_KIND,gad,&ng,
		GT_Underscore,'*',
		GTST_String,"NULL",
		GTST_MaxChars,50,
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 113;
	ng.ng_Width = 90;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GA_imme;
	ng.ng_GadgetText="IMMEDIATE";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 127;
	ng.ng_Width = 90;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GA_relv;
	ng.ng_GadgetText="RELVERIFY";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);


	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 141;
	ng.ng_Width = 90;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSC_free;
	ng.ng_GadgetText="FREEDOM";
	   gad = CreateGadget(CYCLE_KIND,gad,&ng,
		GT_Underscore,'*',
		GTCY_Labels,PGALabels,
		TAG_DONE);

	break;

 case CYCLE_KIND:  /*******************************************************/

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTCY_acti;
	ng.ng_GadgetText="GTCY_Active";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

       break;

 case INTEGER_KIND:  /******************************************************/
	

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTIN_numb;
	ng.ng_GadgetText="GTIN_Number";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTIN_maxc;
	ng.ng_GadgetText="GTIN_MaxChars";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

	break;

  case LISTVIEW_KIND:   /************************************************/

	ng.ng_LeftEdge = 365;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 150;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTLV_show;
	ng.ng_GadgetText="GTLV_ShowSelected";
	   gad = CreateGadget(STRING_KIND,gad,&ng,
		GT_Underscore,'*',
		GTST_String,"NULL",
		GTST_MaxChars,50,
		TAG_DONE);

	ng.ng_LeftEdge = 300;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTLV_scro;
	ng.ng_GadgetText="ScrollWidth";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTLV_top;
	ng.ng_GadgetText="GTLV_Top";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 300;
	ng.ng_TopEdge = top + 125;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTLV_sele;
	ng.ng_GadgetText="Selected";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,~0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 400;
	ng.ng_TopEdge = top + 140;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTLV_read;
	ng.ng_GadgetText="GTLV_ReadOnly";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 125;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = G_layo;
	ng.ng_GadgetText="SPACING";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);
	break;

 case MX_KIND: /*************************************************************/


	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTMX_acti;
	ng.ng_GadgetText="GTMC_Active";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTMX_spac;
	ng.ng_GadgetText="GTMX_Spacing";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,1,
		GTIN_MaxChars,4,
		TAG_DONE);

	break;

	
  case NUMBER_KIND:  /****************************************************/


	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTNM_numb;
	ng.ng_GadgetText="GTNM_Number";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTNM_bord;
	ng.ng_GadgetText="GTNM_Border";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);

	break;


  case PALETTE_KIND:   /*****************************************************/

	ng.ng_LeftEdge = 300;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTPA_dept;
	ng.ng_GadgetText="GTPA_Depth";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,1,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTPA_colo;
	ng.ng_GadgetText="Color";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,1,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 300;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTPA_ocol;
	ng.ng_GadgetText="Offset";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTPA_indw;
	ng.ng_GadgetText="Width";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

  

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 125;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTPA_indh;
	ng.ng_GadgetText="Height";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

  

	break;

  
  case SCROLLER_KIND:  /*************************************************/

	ng.ng_LeftEdge = 300;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSC_top;
	ng.ng_GadgetText="GTSC_Top";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSC_tota;
	ng.ng_GadgetText="GTSC_Total";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,0,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 300;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSC_visi;
	ng.ng_GadgetText="Visible";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,2,
		GTIN_MaxChars,4,
		TAG_DONE);

	ng.ng_LeftEdge = 450;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSC_arro;
	ng.ng_GadgetText="Arrows";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_MaxChars,4,
		TAG_DONE);

  

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 125;
	ng.ng_Width = 95;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTSC_free;
	ng.ng_GadgetText="FREEDOM";
	   gad = CreateGadget(CYCLE_KIND,gad,&ng,
		GT_Underscore,'*',
		GTCY_Labels,PGALabels,
		TAG_DONE);


	ng.ng_LeftEdge = 315;
	ng.ng_TopEdge = top + 140;
	ng.ng_Width = 90;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GA_imme;
	ng.ng_GadgetText="IMMEDIATE";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);

	ng.ng_LeftEdge = 465;
	ng.ng_TopEdge = top + 140;
	ng.ng_Width = 90;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GA_relv;
	ng.ng_GadgetText="RELVERIFY";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);

	break;


  case STRING_KIND:    /*************************************************/

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 150;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTST_stri;
	ng.ng_GadgetText="GTST_String";
	   gad = CreateGadget(STRING_KIND,gad,&ng,
		GT_Underscore,'*',
		GTST_String,"NULL",
		GTST_MaxChars,50,
		TAG_DONE);

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTST_maxc;
	ng.ng_GadgetText="GTST_MaxChars";
	   gad = CreateGadget(INTEGER_KIND,gad,&ng,
		GT_Underscore,'*',
		GTIN_Number,50,
		GTIN_MaxChars,4,
		TAG_DONE);
	
	break;

  case TEXT_KIND:  /********************************************************/


	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 95;
	ng.ng_Width = 150;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTTX_stri;
	ng.ng_GadgetText="GTTX_Text";
	   gad = CreateGadget(STRING_KIND,gad,&ng,
		GT_Underscore,'*',
		GTST_String,"NULL",
		GTST_MaxChars,50,
		TAG_DONE);

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 110;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTTX_copy;
	ng.ng_GadgetText="GTTX_CopyText";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);

	ng.ng_LeftEdge = 355;
	ng.ng_TopEdge = top + 125;
	ng.ng_Width = 55;
	ng.ng_Height = 12;
	ng.ng_GadgetID = GTTX_bord;
	ng.ng_GadgetText="GTTX_Border";
	   gad = CreateGadget(CHECKBOX_KIND,gad,&ng,
		GT_Underscore,'*',
		TAG_DONE);

	break;

    }
 return (gad);
}
